/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8810_SUPSTPO.sql

Descrio:
Atualiza o custo da AF na tabela CUSTOSUP.

Criao:
29/06/2004 Joo Fernando
*/

CREATE OR REPLACE PROCEDURE CUSTO_AF
(
   P_CDFILDEST   IN AUTOFORNE.CDFILDEST%TYPE,
   P_CDFILLANC   IN AUTOFORNE.CDFILLANC%TYPE,
   P_NRAUTOFORN  IN AUTOFORNE.NRAUTOFORN%TYPE,
   P_NRSEQAPURAF IN AUTOFORNE.NRSEQAPURAF%TYPE
)
IS
   V_VRPRCUSAFM1  FLOAT;
   V_VRPRCUSAFM2  FLOAT;
   V_IDUTTPCUSTO  VARCHAR2(1);
   V_IDUTTPCUSTO1 VARCHAR2(1);
   V_IDUTTPCUSTO2 VARCHAR2(1);
   V_IDUTTPCUSTO3 VARCHAR2(1);
   V_CDFORNECED   AUTOFORNE.CDFORNECED%TYPE;
   V_CDPRODCOMPRA ITEMAUTF.CDPRODUTO%TYPE;
BEGIN
   V_VRPRCUSAFM1 := NULL;
   V_VRPRCUSAFM2 := NULL;

   BEGIN
      SELECT IDUTTPCUSTO INTO V_IDUTTPCUSTO
      FROM TIPOCUSTO
      WHERE CDTIPOCUSTO = '07';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTTPCUSTO := 'N';
   END;

   BEGIN
      SELECT IDUTTPCUSTO INTO V_IDUTTPCUSTO1
      FROM TIPOCUSTO
      WHERE CDTIPOCUSTO = '32';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTTPCUSTO1 := 'N';
   END;

   BEGIN
      SELECT IDUTTPCUSTO INTO V_IDUTTPCUSTO2
      FROM TIPOCUSTO
      WHERE CDTIPOCUSTO = '33';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTTPCUSTO2 := 'N';
   END;

   BEGIN
      SELECT IDUTTPCUSTO INTO V_IDUTTPCUSTO3
      FROM TIPOCUSTO
      WHERE CDTIPOCUSTO = '45';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDUTTPCUSTO3 := 'N';
   END;

   IF (V_IDUTTPCUSTO = 'S') OR (V_IDUTTPCUSTO1 = 'S') OR (V_IDUTTPCUSTO2 = 'S') OR (V_IDUTTPCUSTO3 = 'S') THEN
      FOR C_CUSTOAF IN
         (SELECT
             ITEMAUTF.CDFILDEST,
             ITEMAUTF.DTPROGENTAF,
             PRODUTO.CDPRODESTO,
             MIN(ITEMAUTF.VRPREUNIAF/PRODUTO.VRFATOCONV) AS VRMINPRECO
          FROM
             PARAMGERAL,
             PRODUTO,
             (SELECT
                 CDFILDEST,
                 CDFILLANC,
                 NRAUTOFORN,
                 CDFORNECED
              FROM
                 AUTOFORNE
              WHERE
                 CDFILDEST = P_CDFILDEST AND
                 CDFILLANC = P_CDFILLANC AND
                 NRAUTOFORN = P_NRAUTOFORN
              UNION ALL
              SELECT
                 CDFILDEST,
                 CDFILLANC,
                 NRAUTOFORN,
                 CDFORNECED
              FROM
                 AUTOFORNE
              WHERE
                 CDFILLANC   = P_CDFILLANC AND
                 NRSEQAPURAF = P_NRSEQAPURAF) AUTOFORNE,
             ITEMAUTF
          WHERE
             ITEMAUTF.CDFILLANC  = AUTOFORNE.CDFILLANC  AND
             ITEMAUTF.CDFILDEST  = AUTOFORNE.CDFILDEST  AND
             ITEMAUTF.NRAUTOFORN = AUTOFORNE.NRAUTOFORN AND
             PRODUTO.CDPRODUTO   = ITEMAUTF.CDPRODUTO AND
             NOT EXISTS
               (SELECT
                  CDFORNECED
                FROM
                  REFORFIL
                WHERE
                  CDFILIAL   = AUTOFORNE.CDFILDEST   AND
                  CDFORNECED = AUTOFORNE.CDFORNECED AND
                  CDPERIENTR IS NULL)  AND
             (
              (EXISTS (SELECT
                          CDMARCA
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART = '1')                   AND
                          (CDMARCA   = ITEMAUTF.CDMARCA))         ) OR
              (EXISTS (SELECT
                          CDMARCA
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART = '2')                   AND
                          (CDMARCA   = ITEMAUTF.CDMARCA))         ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '4')                   AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '5')                   AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '7')                   AND
                          (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDFORNECED
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  = '8')                   AND
                          (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                          (CDFORNECED = AUTOFORNE.CDFORNECED))     ) OR
              (EXISTS (SELECT
                          CDPRODUTO
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                          (CDTIPPART  IN ('3','6','9')))    ) OR
              (NOT EXISTS (SELECT
                          CDPRODUTO
                       FROM
                          PARTFILI
                       WHERE
                          (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                          (CDPRODUTO  = ITEMAUTF.CDPRODUTO))    )
             ) AND
               (NOT EXISTS (SELECT
                               CDMARCA
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL  = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART = '3')                   AND
                               (CDMARCA   = ITEMAUTF.CDMARCA))         )   AND
               (NOT EXISTS (SELECT
                               CDFORNECED
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART  = '6')                   AND
                               (CDFORNECED = AUTOFORNE.CDFORNECED))     )   AND
               (NOT EXISTS (SELECT
                               CDFORNECED
                            FROM
                               PARTFILI
                            WHERE
                               (CDFILIAL   = ITEMAUTF.CDFILDEST)           AND
                               (CDPRODUTO  = ITEMAUTF.CDPRODUTO) AND
                               (CDTIPPART  = '9')                   AND
                               (CDMARCA    = ITEMAUTF.CDMARCA)      AND
                               (CDFORNECED = AUTOFORNE.CDFORNECED))     )
          GROUP BY
             ITEMAUTF.CDFILDEST,
             ITEMAUTF.DTPROGENTAF,
             PRODUTO.CDPRODESTO)
      LOOP
         IF V_IDUTTPCUSTO1 = 'S' THEN
            SELECT DECODE(NVL(MAX(MOVINDICE.VRINDICE), 0),
                          0, 0,
                          NVL(C_CUSTOAF.VRMINPRECO, 0) / NVL(MAX(MOVINDICE.VRINDICE), 0)) INTO V_VRPRCUSAFM1
            FROM PARAMGERAL, MOVINDICE
            WHERE PARAMGERAL.CDINDICEMF = MOVINDICE.CDINDICE AND
                  MOVINDICE.DTREFIND    = C_CUSTOAF.DTPROGENTAF AND
                  MOVINDICE.CDTPINDICE  = '1' AND
                  MOVINDICE.IDPERVALOR  = '2';
         END IF;

         IF V_IDUTTPCUSTO2 = 'S' THEN
            SELECT DECODE(NVL(MAX(MOVINDICE.VRINDICE), 0),
                          0, 0,
                          NVL(C_CUSTOAF.VRMINPRECO, 0) / NVL(MAX(MOVINDICE.VRINDICE), 0)) INTO V_VRPRCUSAFM2
            FROM PARAMGERAL, MOVINDICE
            WHERE PARAMGERAL.CDINDICEMF2 = MOVINDICE.CDINDICE AND
                  MOVINDICE.DTREFIND     = C_CUSTOAF.DTPROGENTAF AND
                  MOVINDICE.CDTPINDICE   = '1' AND
                  MOVINDICE.IDPERVALOR   = '2';
         END IF;

         BEGIN
            V_CDFORNECED   := NULL;
            V_CDPRODCOMPRA := NULL;
            IF (V_IDUTTPCUSTO3 = 'S') THEN
               SELECT
                  MAX(A.CDFORNECED),
                  MAX(I.CDPRODUTO)
               INTO
                  V_CDFORNECED,
                  V_CDPRODCOMPRA
               FROM
                  PRODUTO P,
                  AUTOFORNE A,
                  ITEMAUTF I
               WHERE
                  A.CDFILDEST                 = C_CUSTOAF.CDFILDEST                         AND
                  A.CDFILLANC                 = P_CDFILLANC                                 AND
                  A.NRAUTOFORN                = NVL(P_NRAUTOFORN, A.NRAUTOFORN)             AND
                  NVL(A.NRSEQAPURAF, '')     = NVL(P_NRSEQAPURAF, NVL(A.NRSEQAPURAF, '')) AND
                  A.CDFILDEST                 = I.CDFILDEST                                 AND
                  A.CDFILLANC                 = I.CDFILLANC                                 AND
                  A.NRAUTOFORN                = I.NRAUTOFORN                                AND
                  I.DTPROGENTAF               = C_CUSTOAF.DTPROGENTAF                       AND
                  P.CDPRODESTO                = C_CUSTOAF.CDPRODESTO                        AND
                  P.CDPRODUTO                 = I.CDPRODUTO                                 AND
                  (I.VRPREUNIAF/P.VRFATOCONV) = C_CUSTOAF.VRMINPRECO;
            END IF;

            UPDATE CUSTOSUP
               SET VRPRCUSTOAF  = DECODE(V_IDUTTPCUSTO, 'S', C_CUSTOAF.VRMINPRECO),
                   VRPRCUSAFM1  = V_VRPRCUSAFM1,
                   VRPRCUSAFM2  = V_VRPRCUSAFM2,
                   CDPRODCUSTAF = V_CDPRODCOMPRA,
                   CDFORNCUSTAF = V_CDFORNECED
               WHERE
                  CDFILIAL = C_CUSTOAF.CDFILDEST AND
                  CDPRODUTO = C_CUSTOAF.CDPRODESTO AND
                  DTCUSTOSUP = C_CUSTOAF.DTPROGENTAF;
            IF SQL%NOTFOUND THEN
               INSERT INTO CUSTOSUP                   
                  (CDFILIAL, CDPRODUTO, DTCUSTOSUP,
                   VRPRCUSTOAF, VRPRCUSAFM1, VRPRCUSAFM2,
                   CDPRODCUSTAF, CDFORNCUSTAF)
               VALUES
                  (C_CUSTOAF.CDFILDEST, C_CUSTOAF.CDPRODESTO, C_CUSTOAF.DTPROGENTAF,
                   DECODE(V_IDUTTPCUSTO, 'S', C_CUSTOAF.VRMINPRECO), V_VRPRCUSAFM1, V_VRPRCUSAFM2,
                   V_CDPRODCOMPRA, V_CDFORNECED);
            END IF;
         END;
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CUSTO_AF','4.11.017'); END;
/

