/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_PADSERV                                                  */
/* Tabela : PADRAOSERV                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_PADSERV'  and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER DTULTATU_PADSERV
  GO


CREATE TRIGGER DTULTATU_PADSERV
ON PADRAOSERV
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                              (SELECT 'PADRAOSERV', NULL, 'CDSERPADDIE='+CDSERPADDIE+';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE PADRAOSERV
      SET DTULTATUPDSV = GETDATE()
      FROM INSERTED
      WHERE
         (PADRAOSERV.CDSERPADDIE = INSERTED.CDSERPADDIE)
   END
END
GO
