ZeedhiDirectives.directive("zhCarousel", function($interval, ScreenService) {
	return {
		restrict: 'A',
		link: function($scope, $element, $attrs) {
			var index = 0;
			var widgetElements, currentWidget, lastWidget, nextWidget;

			function getPreviousWidget() {
				var currentIndex = widgetElements.indexOf(currentWidget);
				var lastIndex;

				if (currentIndex === 0 && widgetElements.length >= 2) {
					lastIndex = widgetElements.length - 1;
				} else {
					lastIndex = currentIndex - 1;
				}

				return widgetElements[lastIndex];
			}

			function getNextWidget() {
				var currentIndex = widgetElements.indexOf(currentWidget);
				var nextIndex;

				if (currentIndex == widgetElements.length - 1) {
					nextIndex = 0;
				} else {
					nextIndex = currentIndex + 1;
				}

				return widgetElements[nextIndex];
			}

			$scope.nextWidget = function() {
				var lastWidgetBkp = lastWidget;
				$(lastWidget).hide();
				$(lastWidget).removeClass("last current next");

				ScreenService.updateTemplate().then(function() {
					$(lastWidgetBkp).show();
				});

				$(currentWidget).removeClass("last current next");
				$(currentWidget).addClass("last");

				$(nextWidget).removeClass("next current last");
				$(nextWidget).addClass("current");

				lastWidget = currentWidget;
				currentWidget = nextWidget;
				nextWidget = getNextWidget();

				$(currentWidget).addClass("current");
				$(lastWidget).addClass("last");
				$(nextWidget).addClass("next");
			};

			$scope.previousWidget = function() {
				$(nextWidget).removeClass("next");

				$(currentWidget).removeClass("current");
				$(currentWidget).addClass("next");

				$(lastWidget).removeClass("last");
				$(lastWidget).addClass("current");

				nextWidget = currentWidget;
				currentWidget = lastWidget;
				lastWidget = getPreviousWidget();

				var lastWidgetBkp = lastWidget;
				$(lastWidget).hide();

				ScreenService.updateTemplate().then(function() {
					$(lastWidgetBkp).show();
				});

				$(currentWidget).addClass("current");
				$(lastWidget).addClass("last");
				$(nextWidget).addClass("next");
			};

			ScreenService.updateTemplate().then(function(){
				$(currentWidget).addClass("current");
				$(lastWidget).addClass("last");
				$(nextWidget).addClass("next");
			});

			$scope.$watchCollection(function() {
				return $element.find(".carousel-child-widget").toArray();
			}, function(elements) {

				widgetElements = elements || [];

				currentWidget = widgetElements[0];
				lastWidget = getPreviousWidget();
				nextWidget = getNextWidget();

				widgetElements.forEach(function(el){
					if (el == currentWidget) {
						$(el).addClass("current"); 
					} else {
						$(el).removeClass("current");
					}
				});
			});

		}
	};
});